#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "hbook.h"

/*********************************/
/*          prototype            */
/*********************************/
int data_open(char *argv);
int data_read(int hai_head[], int hai_data[]);
int data_div(int hai_head[], int hai_data[]);
void data_close(void);
void hbook_init(void);
void hbook_fill1(int i, int hai_data[]);
void hbook_fill2(int i, int hai_data[]);
void hbook_fill3(int i, int hai_data[]);
void hbook_fill4(int i, int hai_data[]);
int hit_number(int x_1, int x_2, int x_3, int y_1, int y_2, int y_3);
void tracking(int , int , int ,
	     int , int , int ,
	     int , int , int ,
	     int , int , int ,
	     int , int , int ,
	     int , int , int ,
	     int , int , int , int ,
	     int , int , int , int );
/*********************************************************/ 
/*                     MWPC section                      */ 
/*********************************************************/ 
int fill_MWPC_1x(int,int,int);
int fill_MWPC_1y(int,int,int);
int fill_MWPC_2x(int,int,int);
int fill_MWPC_2y(int,int,int);
int fill_MWPC_3x(int,int,int);
int fill_MWPC_3y(int,int,int);
int fill_MWPC_4x(int,int,int,int);
int fill_MWPC_4y(int,int,int,int);
double MWPC_hit_position_x( float, float, float, float, int );
double MWPC_hit_position_y( float, float, float, float, int );
/*
double MWPC_hit_position_x1( float, float, float );
double MWPC_hit_position_x2( float, float, float );
double MWPC_hit_position_x3( float, float, float );
double MWPC_hit_position_x4( float, float, float );
double MWPC_hit_position_y1( float, float, float );
double MWPC_hit_position_y2( float, float, float );
double MWPC_hit_position_y3( float, float, float );
double MWPC_hit_position_y4( float, float, float );
*/
double difference_x( float, float, float, float, int );
double difference_y( float, float, float, float, int );
/*---------------- end of MWPC section ------------------*/


/********************************************************/
/*                tracking section                      */
/********************************************************/
double Beam_Position_x( float , float, float,float);
double Beam_Position_y( float, float, float,float);
double gradient_x( float , float , float ,float);
double gradient_y( float , float , float ,float);
double dx1,dx2,dx3,dx4,dy1,dy2,dy3,dy4;
double diff_x1,diff_x2,diff_x3,diff_x4,diff_y1,diff_y2,diff_y3,diff_y4,diff_x,diff_y;
double mwpc_x1,mwpc_x2,mwpc_x3,mwpc_x4,mwpc_y1,mwpc_y2,mwpc_y3,mwpc_y4;
double flag_x1,flag_x2,flag_x3,flag_x4,flag_y1,flag_y2,flag_y3,flag_y4;
double hit_ch_x1,hit_ch_x2,hit_ch_x3,hit_ch_x4;
double hit_ch_y1,hit_ch_y2,hit_ch_y3,hit_ch_y4;
double y1_y2,y1_y3,y1_y4;
double hit_y4;
/*--------------- end of tracking section --------------*/

int main(int argc, char *argv[])
{
  int hid, i;
  double   kk;
  int h,j,k,l,m;
  int a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12;
  int a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24,a25,a26;
  int x_1,x_2,x_3,y_1,y_2,y_3,x_4,y_4;
  float  flag1,flag2,flag3,flag4,flag5,flag6,
    flag7,flag8,flag9,flag10,flag11,flag12,
    flag13,flag14,flag15,flag16,flag17,flag18,flag19,
    flag20,flag21,flag22,flag23,flag24,flag25,flag26;
  /***************************************************/
  /*                  array section                  */
  /***************************************************/
  int x1s[17],x2s[17],x3s[17],x4s[17],x5s[17],x6s[17],
    x7s[17],x8s[17],x9s[17],x10s[17],x11s[17],x12s[17],
    x13s[17],x14s[17],x15s[17],x16s[17],x17s[17],x18s[17],
    x19s[17],x20s[17],x21s[17],x22s[17],x23s[17],x24s[17],
    x25s[17],x26s[17];
  unsigned int b1[17],b2[17],b3[17],b4[17],b5[17],b6[17],
    b7[17],b8[17],b9[17],b10[17],b11[17],b12[17],
    b13[17],b14[17],b15[17],b16[17],b17[17],b18[17],
    b19[17],b20[17],b21[17],b22[17],b23[17],b24[17],
    b25[17],b26[17];
  int cor_x_1=0,cor_x_2=0,cor_x_3=0,cor_x_4,
    cor_y_1=0,cor_y_2=0,cor_y_3=0,cor_y_4;
  float tanx=0.0,tany=0.0; 
  

  /*--------------- tracking format -------------------*/
  FILE *fpout;  
  int  single_hit;
  /*multi hit*/
  int total_x1[49],total_x2[49],total_x3[49],
    total_y1[49],total_y2[49],total_y3[49],total_x4[65],total_y4[65];
  int nx1,nx2,nx3,nx4,nx5,nx6,ny1,ny2,ny3,ny4,ny5,ny6;
  float cor_x1,cor_x2,cor_x3,cor_y1,cor_y2,cor_y3;
  int n,p;
  
  int check_x1,check_x2,check_x3,check_x4;
  double hit_channel_x1,hit_channel_x2,hit_channel_x3,hit_channel_x4;
  int check_y1,check_y2,check_y3,check_y4;
  double single_hit_x1,single_hit_x2,single_hit_x3,single_hit_x4;
  double single_hit_y1,single_hit_y2,single_hit_y3,single_hit_y4;
  double hit_channel_y1,hit_channel_y2,hit_channel_y3,hit_channel_y4;
  double positionx,positiony;
  /*---------------------------------------------------*/
  

  float fnum;
  unsigned int hai_head[6];
  unsigned int hai_data[2048];
  char fname[100];
  strcpy(fname, argv[2]);
  
  /* file open */
  if(argc != 3) exit(1);
  if(data_open(argv[1])==(int)NULL) {
    fprintf(stderr,"can't open raw data file \n");
    exit(2);
  }
  /************ tracking data file open **************/
  /*
  if( ( fpout = fopen( "track.dat","w" ) ) == NULL )
    {
      printf("error !!  can't open tracking data file !\n");
      exit(1);
    }
  */

  /* initialize hbook */
  hbook_init();
  for(i=0; i<200; i++) hai_data[i] = 0;
  hbook_init();
  for(i=0; i<200; i++) hai_data[i] = 0;
  for(i=0; i<=16; i++) 
    {
      b1[i]=b2[i]=b3[i]=b4[i]=b5[i]=b6[i]=0;
      x1s[i]=x2s[i]=x3s[i]=x4s[i]=x5s[i]=x6s[i]=0;
      x7s[i]=x8s[i]=x9s[i]=x10s[i]=x11s[i]=x12s[i]=0;
      x13s[i]=x14s[i]=x15s[i]=x16s[i]=x17s[i]=x18s[i]=0;
      x19s[i]=x20s[i]=x21s[i]=x22s[i]=x23s[i]=x24s[i]=0;
      x25s[i]=x26s[i]=0;
    }
  for(i=0; i<49 ; i++)
    {
      total_x1[i]=total_x2[i]=total_x3[i]=0;
      total_y1[i]=total_y2[i]=total_y3[i]=0;
    }
  for( i = 0; i<64 ; i++ )
    {
      total_x4[i]=total_y4[i]=0;
    }

  x_1=x_2=x_3=y_1=y_2=y_3=x_4=y_4=0;
  single_hit = 0;
  
  /* make array header data */
  while(data_read(hai_head, hai_data) != -1)
    {
      if(data_div(hai_head, hai_data) == 0)
	{
	  /***** ADC trigger *****/
	  for(i=1; i<=12; i++)
	    {                              
	      hbook_fill1(i, hai_data);
	    }
	  
	  /***** TDC trigger *****/
	  for(i=13; i<=26; i++)
	    {
	      hbook_fill2(i, hai_data);
	    }

	  /***** ADC crystal *****/
	  for(i=27; i<=35; i++)
	    {
	      hbook_fill3(i, hai_data);
	    }
	  
	  /***** TDC crystal *****/
	  for(i=36; i<=44; i++)
	    {
	      hbook_fill4(i, hai_data);
	    }

	  /***** MWPC *****/
	  for(i=45; i<=70; i++) 
	    {
	      /***********************/
	      /*      MWPC 1-X       */
	      /***********************/
	      if( i == 70 )
		{   
		  /*fill_MWPC_1x( hai_data[45] , hai_data[47] , hai_data[49]);*/
		  x_1=0;
	          a1=hai_data[45];
		  a2=hai_data[47];
		  a3=hai_data[49];
		  for( l=1 ; l <=16 ; l++ )
		    {
		      b1[l] = a1%2;
		      b2[l] = a2%2;
		      b3[l] = a3%2;
		      a1 = a1/2;
		      a2 = a2/2;
		      a3 = a3/2;
		    }
		  for( j=16 ; j >= 1 ; j-- )
		    {
		      x1s[17-j]=b1[j];
		      x2s[17-j]=b2[j];
		      x3s[17-j]=b3[j];
		    }
		  for( k=1 ; k <= 16 ; k++ )
		    {
		      flag1=(float)x1s[k];
		      flag2=(float)x2s[k];
		      flag3=(float)x3s[k];
		      hf1(500, k,   flag1);
		      hf1(500, k+16,flag2);
		      hf1(500, k+32,flag3);
		      /*
		      kk = (float)k;
		      hf2(520, 1.0,kk,   flag1);
		      hf2(520, 1.0,kk+16.0,flag2);
		      hf2(520, 1.0,kk+32.0,flag3);
		      */
		      x_1 = x_1 + (int)flag1 + (int)flag2 + (int)flag3;
		    }
		  for(m=1;m<=16;m++)
		    {
		      total_x1[m]=x1s[m];
		      total_x1[m+16]=x2s[m];
		      total_x1[m+32]=x3s[m];
		    }
		  hf1(600,x_1,1.0);
		}
	      
	      /***********************/
	      /*      MWPC 1-Y       */
	      /***********************/
	      if( i == 70 )
		{ 
		  /*fill_MWPC_1y( hai_data[46],hai_data[48],hai_data[50]);*/
		  y_1=0;
		  a4=hai_data[46];
		  a5=hai_data[48];
		  a6=hai_data[50];
		  for( l=1 ; l <=16 ; l++ )
		    {
		      b4[l] = a4%2;
		      b5[l] = a5%2;
		      b6[l] = a6%2;
		      a4 = a4/2;
		      a5 = a5/2;
		      a6 = a6/2;
		    }
		  for( j=1 ; j <= 16 ; j++ )
		    {
		      x4s[j]=b4[j];
		      x5s[j]=b5[j];
		      x6s[j]=b6[j];
		    }
		    for( k=1 ; k <= 16 ; k++ )
		      {
			flag4=(float)x4s[k];
			flag5=(float)x5s[k];
			flag6=(float)x6s[k];
			hf1(501, k,   flag4);
			hf1(501, k+16,flag5);
			hf1(501, k+32,flag6);
			/*
			  kk = (float)k;
			  hf2(521, 1.0,kk,     flag4);
			  hf2(521, 1.0,kk+16.0,flag5);
			  hf2(521, 1.0,kk+32.0,flag6);
			*/
			y_1 = y_1 + (int)flag4 + (int)flag5 + (int)flag6;
		      }
		    for(m=1;m<=16;m++)
		      {
			total_y1[m]=x4s[m];
			total_y1[m+16]=x5s[m];
			total_y1[m+32]=x6s[m];
		      }
		    hf1(601,y_1,1.0);  
		}
	      
	      /***********************/
	      /*      MWPC 2-X       */
	      /***********************/
	      if( i == 70 )
		{   
		  /*fill_MWPC_2x( hai_data[51],hai_data[53],hai_data[55]);*/

		  x_2=0;
		  a7=hai_data[51];
		  a8=hai_data[53];
		  a9=hai_data[55];
		  for( l=1 ; l <=16 ; l++ )
		    {
		      b7[l] = a7%2;
		      b8[l] = a8%2;
		      b9[l] = a9%2;
		      a7 = a7/2;
		      a8 = a8/2;
		      a9 = a9/2;
		    }
		  for( j=1 ; j <= 16 ; j++ )
		    {
		      x7s[j]=b7[j];
		      x8s[j]=b8[j];
		      x9s[j]=b9[j];
		    }
		  for( k=1 ; k <= 16 ; k++ )
		    {
		      flag7=(float)x7s[k];
		      flag8=(float)x8s[k];
		      flag9=(float)x9s[k];
		      hf1(502, k,   flag7);
		      hf1(502, k+16,flag8);
		      hf1(502, k+32,flag9);
		      /*
		      kk = (float)k;
		      hf2(520, 2.0,kk,     flag7);
		      hf2(520, 2.0,kk+16.0,flag8);
		      hf2(520, 2.0,kk+32.0,flag9);
		      */
		      x_2 = x_2 + (int)flag7 + (int)flag8 + (int)flag9;
		    }
		  for(m=1;m<=16;m++)
		    {
		      total_x2[m]=x7s[m];
		      total_x2[m+16]=x8s[m];
		      total_x2[m+32]=x9s[m];
		    }
		  hf1(602,x_2,1.0);  
		}
	      
	      /***********************/
	      /*      MWPC 2-Y       */
	      /***********************/
	      if( i == 70 )
		{  
		  /*fill_MWPC_2y( hai_data[52],hai_data[54],hai_data[56]);*/

		  y_2=0;
		  a10=hai_data[52];
		  a11=hai_data[54];
		  a12=hai_data[56];
		  for( l=1 ; l <=16 ; l++ )
		    {
		      b10[l] = a10%2;
		      b11[l] = a11%2;
		      b12[l] = a12%2;
		      a10 = a10/2;
		      a11 = a11/2;
		      a12 = a12/2;
		    }
		  for( j=16 ; j >= 1 ; j-- )
		    {
		      x10s[17-j]=b10[j];
		      x11s[17-j]=b11[j];
		      x12s[17-j]=b12[j];
		    }
		  for( k=1 ; k <= 16 ; k++ )
		    {
		      flag10=(float)x10s[k];
		      flag11=(float)x11s[k];
		      flag12=(float)x12s[k];
		      hf1(503, k,   flag10);
		      hf1(503, k+16,flag11);
		      hf1(503, k+32,flag12);
		      /*
		      kk = (float)k;
		      hf2(521, 2.0,kk,   flag10);
		      hf2(521, 2.0,kk+16.0,flag11);
		      hf2(521, 2.0,kk+32.0,flag12);
		      */
		      y_2 = y_2 + (int)flag10 + (int)flag11 + (int)flag12;
		    }
		  for(m=1;m<=16;m++)
		    {
		      total_y2[m]=x10s[m];
		      total_y2[m+16]=x11s[m];
		      total_y2[m+32]=x12s[m];
		    }
		  hf1(603,y_2,1.0);  
		}
	      
	      /***********************/
	      /*      MWPC 3-X       */
	      /***********************/
	      if( i == 70 )
		{  
		  /*fill_MWPC_3x( hai_data[57],hai_data[59],hai_data[61]);*/

		  x_3=0;
		  a13=hai_data[57];
		  a14=hai_data[59];
		  a15=hai_data[61];
		  for( l=1 ; l <=16 ; l++ )
		    {
		      b13[l] = a13%2;
		      b14[l] = a14%2;
		      b15[l] = a15%2;
		      a13 = a13/2;
		      a14 = a14/2;
		      a15 = a15/2;
		    }
		  for( j=1 ; j <= 16 ; j++ )
		    {
		      x13s[j]=b13[j];
		      x14s[j]=b14[j];
		      x15s[j]=b15[j];
		    }
		  for( k=1 ; k <= 16 ; k++ )
		    {
		      flag13=(float)x13s[k];
		      flag14=(float)x14s[k];
		      flag15=(float)x15s[k];
		      hf1(504, k,   flag13);
		      hf1(504, k+16,flag14);
		      hf1(504, k+32,flag15);
		      /*
		      kk = (float)k;
		      hf2(520, 3.0,kk,     flag13);
		      hf2(520, 3.0,kk+16.0,flag14);
		      hf2(520, 3.0,kk+32.0,flag15);
		      */
		      x_3 = x_3 + (int)flag13 + (int)flag14 + (int)flag15;
		    }
		  for(m=1;m<=16;m++)
		    {
		      total_x3[m]=x13s[m];
		      total_x3[m+16]=x14s[m];
		      total_x3[m+32]=x15s[m];
		    }
		  hf1(604,x_3,1.0);  
		}
	      
	      /***********************/
	      /*      MWPC 3-Y       */
	      /***********************/
	      if( i == 70 )
		{
		  /*fill_MWPC_3y( hai_data[58],hai_data[60],hai_data[62]);*/

		  y_3=0;
		  a16=hai_data[58];
		  a17=hai_data[60];
		  a18=hai_data[62];
		  for( l=1 ; l <=16 ; l++ )
		    {
		      b16[l] = a16%2;
		      b17[l] = a17%2;
		      b18[l] = a18%2;
		      a16 = a16/2;
		      a17 = a17/2;
		      a18 = a18/2;
		    }
		  for( j=17 ; j >= 1 ; j-- )
		    {
		      x16s[17-j]=b16[j];
		      x17s[17-j]=b17[j];
		      x18s[17-j]=b18[j];
		    }
		  for( k=1 ; k <= 16 ; k++ )
		    {
		      flag16=(float)x16s[k];
		      flag17=(float)x17s[k];
		      flag18=(float)x18s[k];
		      hf1(505, k,   flag16);
		      hf1(505, k+16,flag17);
		      hf1(505, k+32,flag18);
		      /*
		      kk = (float)k;
		      hf2(521, 3.0,kk,   flag16);
		      hf2(521, 3.0,kk+16.0,flag17);
		      hf2(521, 3.0,kk+32.0,flag18);
		      */
		      y_3 = y_3 + (int)flag16 + (int)flag17 + (int)flag18;
		    }
		  for(m=1;m<=16;m++)
		    {
		      total_y3[m]=x16s[m];
		      total_y3[m+16]=x17s[m];
		      total_y3[m+32]=x18s[m];
		    }
		  hf1(605,y_3,1.0);  
		}
	      /***********************/
	      /*      MWPC 4-X       */
	      /***********************/
	      if( i == 70 )
		{
		  /*fill_MWPC_4x(  hai_data[63],  hai_data[64],  hai_data[65] ,  hai_data[66] );*/
		  x_4=0;
		  a19=hai_data[63];
		  a20=hai_data[64];
		  a21=hai_data[65];
		  a22=hai_data[66];
		  for( l=1 ; l <=16 ; l++ )
		    {
		      b19[l] = a19%2;
		      b20[l] = a20%2;
		      b21[l] = a21%2;
		      b22[l] = a22%2;
		      a19 = a19/2;
		      a20 = a20/2;
		      a21 = a21/2;
		      a22 = a22/2;
		    }
		  for( j=1 ; j <= 16 ; j++ )
		    {
		      x19s[j]=b19[j];
		      x20s[j]=b20[j];
		      x21s[j]=b21[j];
		      x22s[j]=b22[j];
		    }
		  for( k=1 ; k <= 16 ; k++ )
		    {
		      flag19=(float)x19s[k];
		      flag20=(float)x20s[k];
		      flag21=(float)x21s[k];
		      flag22=(float)x22s[k];
		      hf1(506, k,   flag19);
		      hf1(506, k+16,flag20);
		      hf1(506, k+32,flag21);
		      hf1(506, k+48,flag22);
		      /*
		      kk = (float)k;
		      hf2(520, 4,kk,   flag19);
		      hf2(520, 4,kk+16.0,flag20);
		      hf2(520, 4,kk+32.0,flag21);
		      hf2(520, 4,kk+48.0,flag22);
		      */
		      x_4 = x_4 + (int)flag19 + (int)flag20 + (int)flag21 + (int)flag22;
		      
		    }
		  for(m=1;m<=16;m++)
		    {
		      total_x4[m]=x19s[m];
		      total_x4[m+16]=x20s[m];
		      total_x4[m+32]=x21s[m];
		      total_x4[m+48]=x22s[m];
		    }  
		  hf1(606,x_4,1.0);  
		}
	      
	      /***********************/
	      /*      MWPC 4-Y       */
	      /***********************/
	      if( i == 70 )
		{
		  /*fill_MWPC_4y(  hai_data[67],  hai_data[68],  hai_data[69] ,  hai_data[70] );*/

		  y_4=0;
		  a23=hai_data[67];
		  a24=hai_data[68];
		  a25=hai_data[69];
		  a26=hai_data[70];
		  for( l=1 ; l <=16 ; l++ )
		    {
		      b23[l] = a23%2;
		      b24[l] = a24%2;
		      b25[l] = a25%2;
		      b26[l] = a26%2;
		      a23 = a23/2;
		      a24 = a24/2;
		      a25 = a25/2;
		      a26 = a26/2;
		    }
		  for( j=17 ; j >= 1 ; j-- )
		    {
		      x23s[17-j]=b23[j];
		      x24s[17-j]=b24[j];
		      x25s[17-j]=b25[j];
		      x26s[17-j]=b26[j];
		    }
		  for( k=1 ; k <= 16 ; k++ )
		    {
		      flag23=(float)x23s[k];
		      flag24=(float)x24s[k];
		      flag25=(float)x25s[k];
		      flag26=(float)x26s[k];
		      hf1(507, k,   flag23);
		      hf1(507, k+16,flag24);
		      hf1(507, k+32,flag25);
		      hf1(507, k+48,flag26);
		      /*
		      kk = (float)k;
		      hf2(521, 4,kk,   flag23);
		      hf2(521, 4,kk+16.0,flag24);
		      hf2(521, 4,kk+32.0,flag25);
		      hf2(521, 4,kk+48.0,flag26);
		      */
		      y_4= y_4 +(int)flag23 + (int)flag24 + (int)flag25 + (int)flag26;
		    }
		  for(m=1;m<=16;m++)
		    {
		      total_y4[m]=x23s[m];
		      total_y4[m+16]=x24s[m];
		      total_y4[m+32]=x25s[m];
		      total_y4[m+48]=x26s[m];
		    }
		  hf1(607,y_3,1.0);  
		}
	      
	      /*****************************/
	      /*   Beam position at MWPC   */
	      /*****************************/
	      /*
	      if( i == 70 )
		{
		  for( k = 1 ; k <= 48 ; k++ )
		    {
		      for( j = 1 ; j <= 48 ; j++ )
			{
			  if( total_x1[k] == 1 && total_y1[j] == 1 )
			    {
			      hf2(508,k,j,1.0);
			    }
			  if( total_x2[k] == 1 && total_y2[j] == 1 )
			    {
			      hf2(509,k,j,1.0);
			    }
			  if( total_x3[k] == 1 && total_y3[j] == 1 )
			    {
			      hf2(510,k,j,1.0);
			    }
			}
		    }
		  for( k = 1 ; k <= 64 ; k++ )
		    {
		      for( j = 1 ; j <= 64 ; j++ )
			{
			  if( total_x4[k] == 1 && total_y4[j] == 1 )
			    {
			      hf2(511,k,j,1.0);
			    }
			}
		    }
		}
	      */
	      /*-------------------------------------------------------*/
	      /*                                                       */
	      /*          Beam distribution at BSO crystal             */
	      /*                                                       */
	      /*-------------------------------------------------------*/
	      
	      single_hit_x1 = single_hit_x2 = single_hit_x3 = single_hit_x4 = 0;
	      single_hit_y1 = single_hit_y2 = single_hit_y3 = single_hit_y4 = 0;
	      
	      if(i==70)
		{
		  /*tracking(hai_data[45],hai_data[47],hai_data[49],
			   hai_data[46],hai_data[48],hai_data[50],
			   hai_data[51],hai_data[53],hai_data[55],
			   hai_data[52],hai_data[54],hai_data[56],
			   hai_data[57],hai_data[59],hai_data[61],
			   hai_data[58],hai_data[60],hai_data[62],
			   hai_data[63],hai_data[64],hai_data[65],hai_data[66],
			   hai_data[67],hai_data[68],hai_data[69],hai_data[70]);*/
		  
		  check_x1 = 0;
		  check_x2 = 0;
		  check_x3 = 0;
		  check_x4 = 0;
		  /*************************************************************/
		  /*                                                           */
		  /*                Single Hit Event Section                   */
		  /*                                                           */
		  /*************************************************************/
		  if( x_1 == 1 && x_2 == 1 && x_3 == 1 && x_4 == 1 )
		    {
		      for( j = 1 ; j <= 48 ; j++ )
			{
			  if( total_x1[j] == 1 )
			    {
			      single_hit_x1 = (float)j;
			      flag_x1 = (float)total_x1[j];
			      hit_ch_x1 = (float)j + ( 1.0 / 2.0 );
			      hf1(550, hit_ch_x1, flag_x1);
			    }
			  if( total_x2[j] == 1 )
			    {
			      single_hit_x2 = (float)j;
			      flag_x2 = (float)total_x2[j];
			      hit_ch_x2 = (float)j + ( -1.0 / 2.0 );
			      hf1(552, hit_ch_x2, flag_x2);
			    }
			  if( total_x3[j] == 1 )
			    {
			      single_hit_x3 = (float)j;
			      flag_x3 = (float)total_x3[j];
			      hit_ch_x3 = (float)j + ( 1.0 / 2.0 );
			      hf1(554, hit_ch_x3, flag_x3);
			    }
			}
		      for( j = 1 ; j <= 64 ; j++ )
			{
			  if( total_x4[j] == 1 )
			    {
			      single_hit_x4 = (float)j;
			      flag_x4 = (float)total_x4[j];
			      hit_ch_x4 = (float)j + ( 1.0 / 2.0 );
			      hf1(556, hit_ch_x4, flag_x4);
			    }
			}
		      hf1(700,gradient_x( single_hit_x1,single_hit_x2,
					  single_hit_x3,single_hit_x4),1.0);
		      
		      /*----------------------------------------------------*/
		      /*        MWPC hit pattern and difference of          */
		      /*        single hit event.                           */
		      /*----------------------------------------------------*/
		      dx1 = difference_x(single_hit_x1,single_hit_x2,single_hit_x3,single_hit_x4, 1);
		      dx2 = difference_x(single_hit_x1,single_hit_x2,single_hit_x3,single_hit_x4, 2);
		      dx3 = difference_x(single_hit_x1,single_hit_x2,single_hit_x3,single_hit_x4, 3);
		      dx4 = difference_x(single_hit_x1,single_hit_x2,single_hit_x3,single_hit_x4, 4);
		      mwpc_x1 = MWPC_hit_position_x(single_hit_x1,single_hit_x2,single_hit_x3,single_hit_x4, 1);
		      mwpc_x2 = MWPC_hit_position_x(single_hit_x1,single_hit_x2,single_hit_x3,single_hit_x4, 2);
		      mwpc_x3 = MWPC_hit_position_x(single_hit_x1,single_hit_x2,single_hit_x3,single_hit_x4, 3);
		      mwpc_x4 = MWPC_hit_position_x(single_hit_x1,single_hit_x2,single_hit_x3,single_hit_x4, 4);
		      
		      hf2(530,single_hit_x1,dx1,1.0);
		      hf2(532,single_hit_x2,dx2,1.0);
		      hf2(534,single_hit_x3,dx3,1.0);
		      hf2(536,single_hit_x4,dx4,1.0);
		      
		      hf1(540,dx1,1.0);
		      hf1(542,dx2,1.0);
		      hf1(544,dx3,1.0);
		      hf1(546,dx4,1.0);
		      
		      hf1(560,mwpc_x1,1.0);
		      hf1(562,mwpc_x2,1.0);
		      hf1(564,mwpc_x3,1.0);
		      hf1(566,mwpc_x4,1.0);
		    }
		  /*--------------------------------------------------------------*/
		  
		  if( x_1 == 1 )
		    {
		      for( h = 1 ; h <= 48 ; h++ )
			{
			  if( total_x1[h] == 1 )
			    {
			      hit_channel_x1 = (float)h;
			      check_x1 = 1;
			    }
			}
		    }
		  if( x_1 == 2 )
		    {
		      for( h = 1 ; h <= 47 ; h++ )
			{
			  if( total_x1[h] == 1 && total_x1[h+1] == 1)
			    {
			      hit_channel_x1=(float)(2*h+1)/2;
			      check_x1 = 1;
			    }
			}
		    }
		  if( x_1 == 3 )
		    {
		      for( h = 1 ; h <= 46 ; h++ )
			{
			  if( total_x1[h] == 1 && total_x1[h+1] == 1 && total_x1[h+2] == 1 )
			    {
			      hit_channel_x1=(float)(h+1);
			      check_x1 = 1;
			    }
			}
		    }
		  
		  if( check_x1 == 1 )
		    {
		      if( x_2 == 1 )
			{
			  for( h = 1; h <= 48 ; h++ )
			    {
			      if( total_x2[h] == 1 )
				{
				  hit_channel_x2 = (float)h;
				  check_x2 = 1;
				}
			    }
			}
		      if( x_2 == 2 )
			{
			  for( h = 1 ; h <= 47 ; h++ )
			    {
			      if( total_x2[h] == 1 && total_x2[h+1] )
				{
				  hit_channel_x2=(float)(2*h+1)/2;
				  check_x2 = 1;
				}
			    }
			}
		      if( x_2 == 3 )
			{
			  for( h = 1 ; h <= 46 ; h++ )
			    {
			      if( total_x2[h] == 1 && total_x2[h+1] == 1 && total_x2[h+2] == 1)
				{
				  hit_channel_x2=(float)(h+1);
				  check_x2 = 1;
				}
			    }
			}
		    }
		  
		  if( check_x1==1 && check_x2==1 )
		    {
		      if( x_3 == 1 )
			{
			  for( h = 1; h <= 48 ; h++ )
			    {
			      if( total_x3[h] == 1 )
				{
				  hit_channel_x3 = (float)h;
				  check_x3 = 1;
				}
			    }
			}
		      if( x_3 == 2 )
			{
			  for( h = 1; h <= 47 ; h++ )
			    {
			      if( total_x3[h] == 1 && total_x3[h+1] == 1 )
				{
				  hit_channel_x3=(float)(2*h+1)/2;
				  check_x3 = 1;
				}
			    }
			}
		      if( x_3 == 3 )
			{
			  for( h = 1 ; h <= 46 ; h++ )
			    {
			      if( total_x3[h] == 1 && total_x3[h+1] == 1 && total_x3[h+2] == 1 )
				{
				  hit_channel_x3=(float)(h+1);
				  check_x3 = 1;
				}
			    }
			}
		    }
		  
		  if( check_x1==1 && check_x2==1 && check_x3==1 )
		    {
		      if( x_4 == 1 )
			{
			  for( h = 1; h <= 64 ; h++ )
			    {
			      if( total_x4[h] == 1 )
				{
				  hit_channel_x4=(float)(h);
				  check_x4 = 1;
				}
			    }
			}
		      if( x_4 == 2 )
			{
			  for( h = 1 ; h <= 63 ; h++ )
			    {
			      if( total_x4[h] == 1 && total_x4[h+1] == 1 )
				{
				  hit_channel_x4=(float)(2*h+1)/2;
				  check_x4 = 1;
				}
			    }
			}
		      if( x_4 == 3 )
			{
			  for( h = 1; h <= 62 ; h++ )
			    {
			      if( total_x4[h] == 1 && total_x4[h+1] == 1 && total_x4[h+2] == 1 )
				{
				  hit_channel_x4=(float)(h+1);
				  check_x4 = 1;
				}
			    }
			}
		    }
		  
		  check_y1 = 0;
		  check_y2 = 0;
		  check_y3 = 0;
		  check_y4 = 0;
		  
		  /******************************************************/
		  /*        MWPC hit pattern of single hit event        */
		  /******************************************************/
		  if( y_1 == 1 && y_2 == 1 && y_3 == 1 && y_4 == 1 )
		    {
		      /*---------------------------------*/
		      /* serching the single hit channel */
		      /*---------------------------------*/
		      for( j = 1 ; j <= 48 ; j++ )
			{
			  if( total_y1[j] == 1 )
			    {
			      single_hit_y1 = (float)j;
			      flag_y1 = (float)total_y1[j];
			      hit_ch_y1 = (float)j;
			      hf1(551,hit_ch_y1,flag_y1);
			    }
			  if( total_y2[j] == 1 )
			    {
			      single_hit_y2 = (float)j;
			      flag_y2 = (float)total_y2[j];
			      hit_ch_y2 = (float)j + ( -0.5 / 2.0 );
			      hf1(553,hit_ch_y2,flag_y2);
			    }
			  if( total_y3[j] == 1 )
			    {
			      single_hit_y3 = (float)j;
			      flag_y3 = (float)total_y3[j];
			      hit_ch_y3 = (float)j + ( -0.5 / 2.0 );
			      hf1(555,hit_ch_y3,flag_y3);
			    }
			}
		      for( j = 1 ; j <= 64 ; j++ )
			{
			  if( total_y4[j] == 1 )
			    {
			      single_hit_y4 = (float)j;
			      flag_y4 = (float)total_y4[j];
			      hit_ch_y4 = (float)j + ( 0.5 / 2.0 );
			      hf1(557,hit_ch_y4,flag_y4);
			    }
			}
		      hf1(701,gradient_y( single_hit_y1,single_hit_y2,
					  single_hit_y3,single_hit_y4),1.0);
		      
		      dy1 = difference_y(single_hit_y1,single_hit_y2,single_hit_y3,single_hit_y4, 1);
		      dy2 = difference_y(single_hit_y1,single_hit_y2,single_hit_y3,single_hit_y4, 2);
		      dy3 = difference_y(single_hit_y1,single_hit_y2,single_hit_y3,single_hit_y4, 3);
		      dy4 = difference_y(single_hit_y1,single_hit_y2,single_hit_y3,single_hit_y4, 4);
		      mwpc_y1 = MWPC_hit_position_y(single_hit_y1,single_hit_y2,single_hit_y3,single_hit_y4, 1);
		      mwpc_y2 = MWPC_hit_position_y(single_hit_y1,single_hit_y2,single_hit_y3,single_hit_y4, 2);
		      mwpc_y3 = MWPC_hit_position_y(single_hit_y1,single_hit_y2,single_hit_y3,single_hit_y4, 3);
		      mwpc_y4 = MWPC_hit_position_y(single_hit_y1,single_hit_y2,single_hit_y3,single_hit_y4, 4);
		      
		      hf2(531,single_hit_y1,dy1,1.0);
		      hf2(533,single_hit_y2,dy2,1.0);
		      hf2(535,single_hit_y3,dy3,1.0);
		      hf2(537,single_hit_y4,dy4,1.0);
		      
		      hf1(541,dy1,1.0);
		      hf1(543,dy2,1.0);
		      hf1(545,dy3,1.0);
		      hf1(547,dy4,1.0);
		      
		      hf1(561,mwpc_y1,1.0);
		      hf1(563,mwpc_y2,1.0);
		      hf1(565,mwpc_y3,1.0);
		      hf1(567,mwpc_y4,1.0);
		    }
		  /*--------------------------------------------------------------*/
		  if( y_1 == 1 )
		    {
		      for( h = 1; h <= 48 ; h++ )
			{
			  if( total_y1[h] == 1 )
			    {
			      hit_channel_y1 = (float)h;
			      check_y1 = 1;
			    }
			}
		    }
		  if( y_1 == 2 )
		  {
		      for( h = 1 ; h <= 47 ; h++ )
			{
			  if( total_y1[h] == 1 && total_y1[h+1] == 1 )
			    {
			      hit_channel_y1=(float)(2*h+1)/2;
			      check_y1 = 1;
			    }
			}
		    }
		  if( y_1 == 3 )
		    {
		      for( h = 1 ; h <= 46 ; h++ )
			{
			  if( total_y1[h] == 1 && total_y1[h+1] == 1 && total_y1[h+2] == 1)
			    {
			      hit_channel_y1=(float)(h+1);
			      check_y1 = 1;
			    }
			}
		    }
		  if( check_y1 == 1 )
		    {
		      if( y_2 == 1 )
			{
			  for( h = 1 ; h <= 48 ; h++ )
			    {
			      if( total_y2[h] == 1 )
				{
				  hit_channel_y2 = (float)h;
				  check_y2 = 1;
				}
			    }
			}
		      if( y_2 == 2  )
			{
			  for( h = 1 ; h <= 47 ; h++ )
			    {
			      if( total_y2[h] == 1 && total_y2[h+1] == 1 )
				{
				  hit_channel_y2=(float)(2*h+1)/2;
				  check_y2 = 1;
				}
			    }
			}
		      if( y_2 == 3 )
			{
			  for( h = 1 ; h <= 46 ; h++ )
			    {
			      if( total_y2[h] == 1 && total_y2[h+1] == 1 && total_y2[h+2] == 1 )
				{
				  hit_channel_y2=(float)(h+1);
				  check_y2 = 1;
				}
			    }
			}
		    }

		  if( check_y1 == 1 && check_y2 == 1 )
		    {
		      if( y_3 == 1 )
			{
			  for( h = 1 ; h <= 48 ; h++ )
			    {
			      if( total_y3[h] == 1 )
				{
				  hit_channel_y3 = (float)h;
				  check_y3 = 1;
				}
			    }
			}
		      if( y_3 == 2 )
			{
			  for( h = 1 ; h <= 47 ; h++ )
			    {
			      if( total_y3[h] == 1 && total_y3[h+1] == 1 )
				{
				  hit_channel_y3=(float)(2*h+1)/2;
				  check_y3 = 1;
				}
			    }
			}
		      if( y_3 == 3 )
			{
			  for( h = 1 ; h <= 46 ; h++ )
			    {
			      if( total_y3[h] == 1 && total_y3[h+1] == 1 && total_y3[h+2] == 1 )
				{
				  hit_channel_y3=(float)(h+1);
				  check_y3 = 1;
				}
			    }
			}
		    }
		  
		  if( check_y1 == 1 && check_y2 == 1 && check_y3 == 1 )
		    {
		      if( y_4 == 1 )
			{
			  for( h = 1 ; h <= 64 ; h++ )
			    {
			      if( total_y4[h] == 1 )
				{
				  hit_channel_y4=(float)(h);
				  check_y4 = 1;
				}
			    }
			}
		      if( y_4 == 2 )
			{
			  for( h = 1; h <= 63 ; h++ )
			    {
			      if( total_y4[h] == 1 && total_y4[h+1] == 1 )
				{
				  hit_channel_y4=(float)(2*h+1)/2;
				  check_y4 = 1;
				}
			    }
			}
		      if( y_4 == 3 )
			{
			  for( h = 1 ; h <= 62 ; h++ )
			    {
			      if( total_y4[h] == 1 && total_y4[h+1] == 1 && total_y4[h+2] == 1 )
				{
				  hit_channel_y4=(float)(h+1);
				  check_y4 = 1;
				}
			    }
			}
		    }
		  
		  /****************************************************/
		  /*          beam angle of multi hit event           */
		  /****************************************************/
		  if( check_x1 == 1 && check_x2 == 1 && check_x3 == 1 && check_x4 == 1 )
		    {
		      hf1(800,gradient_x(hit_channel_x1,hit_channel_x2,
					 hit_channel_x3,hit_channel_x4),1.0);
		    }

		  if( check_y1 == 1 && check_y2 == 1 && check_y3 == 1 && check_y4 == 1 )
		    {
		      hf1(801,gradient_y(hit_channel_y1,
					 hit_channel_y2,hit_channel_y3,hit_channel_y4),1.0);
		    }
		  if( x_1 == 1 && x_2 == 1 && x_3 == 1 && x_4 == 1 &&
		      y_1 == 1 && y_2 == 1 && y_3 == 1 && y_4 == 1    )
		    {
		      hf2(1001,Beam_Position_x( hit_channel_x1,
						hit_channel_x2,
						hit_channel_x3,
						hit_channel_x4),
			  Beam_Position_y( hit_channel_y1,
					   hit_channel_y2,
					   hit_channel_y3,
					   hit_channel_y4),1.0);
		    }
		  /***************************************************/
		  /*                Beam tracking                    */
		  /***************************************************/
		  /* multi hit */
		  if( check_x1 == 1 && check_x2 == 1 && check_x3 == 1 && check_x4 == 1 &&
		      check_y1 == 1 && check_y2 == 1 && check_y3 == 1 && check_y4 == 1    )
		    {
		      hit_channel_x1 = hit_channel_x1; 
                      hit_channel_x2 = hit_channel_x2; 
                      hit_channel_x3 = hit_channel_x3; 
                      hit_channel_x4 = hit_channel_x4; 
		      
                      hit_channel_y1 = hit_channel_y1;  
                      hit_channel_y2 = hit_channel_y2;
                      hit_channel_y3 = hit_channel_y3;  
                      hit_channel_y4 = hit_channel_y4;  
		      
		      hf2(1000,
			  Beam_Position_x(hit_channel_x1,hit_channel_x2,
					  hit_channel_x3,hit_channel_x4),
			  Beam_Position_y(hit_channel_y1,hit_channel_y2,
					  hit_channel_y3,hit_channel_y4),1.0);
		    }
		  /********************************/
		  /*     position of each mwpc    */
		  /********************************/
		  
		  hit_channel_x1 = hit_channel_x2 = hit_channel_x3 = hit_channel_x4 = 0;
		  hit_channel_y1 = hit_channel_y2 = hit_channel_y3 = hit_channel_y4 = 0;
		}
	      
	      /*------------------- end of multi hit ----------------*/
	      
	    }      
	} 
    }   
  hrput(0, fname, "n");
  data_close();
  return 0;
}
